;; -*- lexical-binding: t; -*-

(defun srb-test ()
  (interactive)
  (srb-test--next srb-test--key-groups nil))

(defvar srb-test--key-groups '(("i" "p") ("y" "k") ("c" "d" "n") "t" ("h" "r")))

(defun srb-test--next (groups keys-so-far)
  (let* ((map (make-sparse-keymap))
	 (key-list '("i" "p" "y" "k" "c" "d" "n" "t" "h" "r"))
         ;; The key just typed.
         (this-key (lambda () (char-to-string last-command-event)))
         (prompt nil)
         ;; Remove groups of entered keys from prompt and show remaining.
         (add-to-prompt
	  (lambda (key)
	    (setq prompt
		  (concat prompt
			  (format
			   (concat
			    (if (member key '("i" "y" "c" "t" "h")) "{" " ")
			    "%s"
			    (when (member key '("p" "k" "n" "t" "r")) "} "))
			   key)))))
         ;; Return the key groups replacing the group containing the given key
         ;; by the key itself.
         (get-groups
          (lambda (key lst)
            (setq lst (if (consp lst) lst (list lst)))
            (let ((l nil) ky)
              (mapc (lambda (m)
                      (when (consp m)
                        (catch 'found1
                          (dolist (k m)
                            (when (equal key k)
                              (throw 'found1 (setq ky k))))))
                      (if ky
			  (progn (push ky l) (setq ky nil))
                        (push m l)))
                    lst)
              (setq lst (reverse l)))))
         ;; Operate on a copy of the groups list so the original is not
         ;; consumed, thus available for the next key typed.
         (groups0 groups)
	 ;; exitfn
	 )
    (while groups0
      (let* ((x (car groups0))
             (restgroups (cdr groups0)))
        (dolist (key (if (consp x) x (list x)))
          (funcall add-to-prompt key)
          (define-key map key
	    (if (null restgroups)
		(lambda () (interactive)
		  (setq keys-so-far (concat keys-so-far " " (funcall this-key)))
		  (message "Keys:%s" keys-so-far))
	      (lambda () (interactive)
		(setq keys-so-far (concat keys-so-far " " (funcall this-key)))
		(srb-test--next
		 (cdr (funcall get-groups (funcall this-key) groups))
		 keys-so-far)))))
	(setq groups0 restgroups)))
    (set-transient-map map)
    ;; (setq exitfn (set-transient-map map))
    (when prompt (message "Press a key from one of these groups: %s" prompt))
    (setq groups0 groups)
    ;; (funcall exitfn)
    ))

(provide 'test-edebug-override-map)
